#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	ofBackground(255, 255, 255);
	//ofSetWindowShape(500, 500);
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
		
	for (int i = 0; i < 1000; i++){
		particle myParticle;
		float vx = ofRandom(-4,4);
		float vy = ofRandom(-4,4);
	
		myParticle.setInitialCondition(300,300,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}
	
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	int bob = int(ofGetFrameNum());
	
	if (bob % 150 == 0) {
		for (int i = 0; i < particles.size(); i++){
			float vx = ofRandom(-4,4);
			float vy = ofRandom(-4,4);
			
			
			float degree=ofRandom(0, TWO_PI); 
			float r = ofRandom(10, 50);
			
			float x=r*cos(degree); 
			float y=r*sin(degree); 
			
			
			
			
			particles[i].setInitialCondition(x,y,vx, vy);	
			
			posX =ofRandom(0, 500);
			posY = ofRandom(0, 500);
			thered =ofRandom(0, 255);
			thegreen = ofRandom(0, 255);
			theblue = ofRandom(0, 255);
		}
	}
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		//particles[i].addForce(0,0.04);  // gravity
		particles[i].addDampingForce();
		particles[i].update();
	}
	

}

//--------------------------------------------------------------
void testApp::draw(){
	
	
	ofSetColor(thered, thegreen, theblue, 100);
	ofTranslate(posX, posY, 0);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	


}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
